// LCD Clock

#define XTAL	3686400
#define F_CPU	XTAL

#include <stdlib.h> 
#include <stdio.h>
#include <avr/interrupt.h>
#include <util/delay.h>

#include "..\..\includes\BitUtilities.h"
#include "..\..\includes\LCD_display.h"
volatile int tc;
char hr=20, min=0, sec=0;
char str[2];

ISR(TIMER1_OVF_vect)
{	TCNT1 = 34286; tc++;
}

int main(void)
{	TIMSK |= _BV(TOIE1); 	// aktivate overflow interrupt of timer1 
	TCCR1B |= (1<<CS12);	// prescaler = 256
	TCNT1 = 0xFFFF; 		// FFFF for start 
	sei();	
	
	lcd_init(); lcd_send(COMMAND, LCD_CLEAR);
	lcd_set_cursor (1, 4);lcd_write ("10:00:00");
	lcd_set_cursor (2, 4);lcd_write ("Hallo");		
	
	while(1)
	{	sec=tc;
		if (sec==60)
		{	tc=0; sec=0; min++;
			if (min==60) {min=0; hr++; if (hr==24) hr=0;}
			sprintf(str,"%02d",min); lcd_set_cursor (1, 7); lcd_write (str);
			sprintf(str,"%02d",hr);  lcd_set_cursor (1, 4); lcd_write (str);
		}
		sprintf(str,"%02d",sec); lcd_set_cursor (1, 10); lcd_write (str);
		lcd_set_cursor (1, 0); lcd_write ("Uhr");
		lcd_set_cursor (2, 10); lcd_write ("OK");
		while(sec == tc);
	}		
	return(0);
}



